
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Unity shader学习之Blinn-Phong光照模型 / 憋错料</title>

    <meta name="description" content="Unity shader学习之Blinn-Phong光照模型 Blinn-Phong光照模型不用计算反射方向,计算公式如下: h = normalize(v + l); Cspecular = Clight * mspecular * pow(max(0, dot(n, h), gloss)) 转载请注明出处:http://www.cnblogs.com/jietian331/p/7097201.html shader如下: 1 Shader &quot;Custom/Specular Blinn-Phong&quot; 2 { 3 Properties  ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Unity shader学习之Blinn-Phong光照模型</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>Blinn-Phong光照模型不用计算反射方向，计算公式如下：</p>
<p><strong>h = normalize(v + l);</strong></p>
<p><strong>C<sub>specular</sub> = C<sub>light</sub> * m<sub>specular</sub> * pow(max(0, dot(n, h), gloss))</strong></p>
<p>转载请注明出处：<a href="http://www.cnblogs.com/jietian331/p/7097201.html" rel="external nofollow noreferrer">http://www.cnblogs.com/jietian331/p/7097201.html</a></p>
<p>shader如下：</p>
<pre> 1 Shader "Custom/Specular Blinn-Phong"
 2 {
 3     Properties
 4     {
 5         _Diffuse ("Diffuse Color", Color) = (1,1,1,1)
 6         _Specular ("Specular Color", Color) = (1,1,1,1)
 7         _Gloss ("Gloss", Range(8, 256)) = 8
 8     }
 9     SubShader
10     {
11         Tags { "RenderType"="Opaque" }
12         LOD 100
13
14         Pass
15         {
16             Tags { "LightMode"="ForwardBase" }
17
18             CGPROGRAM
19             #pragma vertex vert
20             #pragma fragment frag
21
22             #include "UnityCG.cginc"
23             #include "Lighting.cginc"
24
25             struct appdata
26             {
27                 float4 vertex : POSITION;
28                 float3 normal : NORMAL;
29             };
30
31             struct v2f
32             {
33                 float4 vertex : SV_POSITION;
34                 float3 worldPos : TEXCOORD0;
35                 float3 worldNormal : TEXCOORD1;
36             };
37
38             fixed4 _Diffuse;
39             fixed4 _Specular;
40             float _Gloss;
41
42             v2f vert (appdata v)
43             {
44                 v2f o;
45                 o.vertex = UnityObjectToClipPos(v.vertex);
46                 o.worldNormal = UnityObjectToWorldNormal(v.normal);
47                 o.worldPos = mul(unity_ObjectToWorld, v.vertex);
48                 return o;
49             }
50
51             fixed4 frag (v2f i) : SV_Target
52             {
53                 // specular
54                 float3 worldNormal = normalize(i.worldNormal);
55                 float3 lightDir = UnityWorldSpaceLightDir(i.worldPos);
56                 lightDir = normalize(lightDir);
57                 float3 viewDir = UnityWorldSpaceViewDir(i.worldPos);
58                 viewDir = normalize(viewDir);
59                 float3 halfDir = normalize(lightDir + viewDir);
60                 float d = max(0, dot(halfDir, worldNormal));
61                 float3 spec = _LightColor0.rgb * _Specular.rgb * pow(d, _Gloss);
62
63                 // diffuse
64                 float3 diff = _LightColor0.rgb * _Diffuse.rgb * max(0, dot(lightDir, worldNormal));
65
66                 float3 c = spec + diff + UNITY_LIGHTMODEL_AMBIENT.rgb;
67                 return fixed4(c, 1);
68             }
69             ENDCG
70         }
71     }
72 }</pre>
<p>效果如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzUwOTkxNS8yMDE3MDYvNTA5OTE1LTIwMTcwNjMwMDg1OTQzNTg2LTE3MjEzNzY3OTYucG5n.jpg"></p>
<p>这种光照模型的高光反射看起来更大，更亮一些。在实际渲染中，绝大多数情况会选择 Blinn-Phong 光照模型，此种光照模型更符合实验结果。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-15 01:40:13 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/type/" title="type">type</a>, <a href="https://www.biecuoliao.com/tag/pac/" title="pac">pac</a>, <a href="https://www.biecuoliao.com/tag/osi/" title="osi">osi</a>, <a href="https://www.biecuoliao.com/tag/blank/" title="blank">blank</a>, <a href="https://www.biecuoliao.com/tag/div/" title="div">div</a>, <a href="https://www.biecuoliao.com/tag/%e6%83%85%e5%86%b5/" title="情况">情况</a>, <a href="https://www.biecuoliao.com/tag/%e5%8f%8d%e5%b0%84/" title="反射">反射</a>, <a href="https://www.biecuoliao.com/tag/dba/" title="dba">dba</a>, <a href="https://www.biecuoliao.com/tag/htc/" title="htc">htc</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Unity shader学习之Blinn-Phong光照模型的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MB7kxy0.html" rel="bookmark">Unity Shader 学习之旅-初探</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Unity Shader 学习之旅-初探 unity shader 图形图像 美丽的梦和美丽的诗一样 都是可遇而不可求的--席慕蓉 最简单的顶点片元着色器 顶点片元着色器基本结构 Unity Shader基本结构:Shader ,Properties,SubShder,Fallback等. 结构 Shader &quot;ShaderName&quot;{  Properties{  //属性,暴露在inspector面板上  }  SubShader{  //针对显卡A的SubShader  Pass{			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JDmXn0.html" rel="bookmark">Unity Shader学习笔记（一）坐标变换</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基本问题 试想我们的美术做了一个3D模型,然后渲染引擎把模型渲染到屏幕上.我们还可以选定不同的视角,模拟不同的光照条件去观察模型.现在来分析一下这个过程.如果说我们把这个过程看成一个函数,那么函数的输出就是屏幕上的图像.确切地说,是屏幕上的每个像素.这个函数的主要输入是这个3D模型,我们观察的视角,光照情况等等因素.渲染过程就是给出这些因素决定每个像素值的过程. 首先来看模型.模型通常是由可视化的建模软件制作,看上去是一个&quot;实体&quot;.然而从计算机的角度来说,模型文件只不过是包含渲染它所需			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OZZGo0.html" rel="bookmark">Unity shader学习之逐像素漫反射光照模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				shader如下: Shader &quot;Custom/Diffuse Fragment-Level&quot; { Properties { _Diffuse (&quot;Diffuse&quot;, Color) = (1,1,1,1) } SubShader { Tags { &quot;RenderType&quot;=&quot;Opaque&quot; } LOD 100 Pass { Tags { &quot;LightMode&quot;=&quot;ForwardBase&quot			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgEzQg3.html" rel="bookmark">Unity shader学习之半兰伯特光照模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				半兰伯特光照模型,为Valve公司在开发游戏&lt;半条命&gt;时提出的一种技术,用于解决漫反射光无法到达区域无任凭明暗变化,丢失模型细节表现的问题. 其公式如下: Cdiffuse = Clight * mdiffuse * ( dot(n, l) * 0.5 +0.5 ) 通过这样的方式,将dot(n, l)的结果从[-1,1]映射到[0,1]的范围. 转载请注明出处:http://www.cnblogs.com/jietian331/p/7083289.html shader如下: Shader			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41eP8G4.html" rel="bookmark">Unity shader学习之阴影，衰减统一处理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用unity AutoLight.cginc文件里的内置函数 UNITY_LIGHT_ATTENUATION shader如下: // Upgrade NOTE: replaced 'mul(UNITY_MATRIX_MVP,*)' with 'UnityObjectToClipPos(*)' Shader &quot;Custom/Forward Rendering&quot; { Properties { _MainTex(&quot;Main Texture&quot;, 2D) = &quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoqDYD3.html" rel="bookmark">Unity shader学习之屏幕后期效果之调整屏幕亮度，饱和度，对比度</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Unity的屏幕后期处理效果,使用MonoBehaviour.OnRenderImage来实现. 如代码如下: PostEffectRenderer: 1 using UnityEngine; 2 3 [RequireComponent(typeof(Camera))] 4 public abstract class PostEffectRenderer : GameBehaviour 5 { 6 protected abstract string ShaderName { get; } 7 8			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Rwxnj3.html" rel="bookmark">unity shader 学习 （2）Vs【顶点着色器】 和 Ps【像素着色器】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一章我写了渲染管线,中间提到了shader的作用,我们的大shader同学主要就是负责被CPU指派到GPU中做一些如顶点转换,关照模型,光栅化等操作的. 大shader有两种类型,他们分别是Vs[顶点着色器] 和 Ps[像素着色器].. 他们可以同时存在,也可以分开存在,没有任何使用限制. 当时如果同时存在的话,必须Vs执行完成后再交给Ps处理. 他们两个家伙是配合固定流程管线而存在的.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38DL5g3.html" rel="bookmark">Unity shader学习之屏幕后期处理效果之高斯模糊</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				高斯模糊,见 百度百科. 也使用卷积来实现,每个卷积元素的公式为: 其中б是标准方差,一般取值为1. x和y分别对应当前位置到卷积中心的整数距离. 由于需要对高斯核中的权重进行归一化,即使所有权重相加为1,因此e前面的系数实际不会对结果产生任何影响. 综上,公式简化为: G(x,y) = e-(x*x+y*y)/2 一个5 * 5的高斯核计算代码如下: 1 using System; 2 3 namespace TestShell 4 { 5 class Program 6 { 7 static			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lmOlZ3.html" rel="bookmark">【我的书】Unity Shader的书 &mdash; 目录（实时更新中）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				写在前面 感谢所有点进来看的朋友.没错,我目前打算写一本关于Unity Shader的书. 出书的目的有下面几个: 总结我接触Unity Shader以来的历程,给其他人一个借鉴.我非常明白学Shader的艰难,在群里也见了很多人提出的问题.我觉得学习Shader还是一件有规律可循的事情,但问题是中文资料难觅,而大家又不愿意去看英文...这对我有什么好处呢?强迫我对知识进行梳理,对细节问题把握更清楚. 第二个原因你懂的. 关于本书的定位问题: 面向Unity Shader初学者,但要: 有一定的			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/NMykae3.html" rel="bookmark" class="title">nil&sol;Nil&sol;NULL&sol;NSNull区别</a>
					<div>
						nil:指向oc中对象的空指针 Nil:指向oc中类的空指针 NULL:指向其他类型的空指针,如一个c类型的内存指针 NSNull:在集合对象中,表示空值的对象 若obj为nil: ［obj mess ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r0aV5v3.html" rel="bookmark" class="title">linux快捷键</a>
					<div>
						1.Ctrl + C:这个是用来终止当前命令的快捷键,当然你也可以输入一大串字符,不想让它运行直接Ctrl + C,光标就会跳入下一行. 2.Tab: 这个键是最有用的键了,也是阿铭敲击概率最高的一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YggbJ4.html" rel="bookmark" class="title">Project Euler 104&colon;Pandigital Fibonacci ends 两端为全数字的斐波那契数</a>
					<div>
						Pandigital Fibonacci ends The Fibonacci sequence is defined by the recurrence relation: F[n] = F[n-1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dxWP70.html" rel="bookmark" class="title">soapui调试测试用例</a>
					<div>
						开始 本指南将向您展示如何开始使用TestCase调试. 导入在home文件夹中的soapUI-Tutorials文件夹中找到的sample-soapui-pro-project.xml项目.如果没有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXdLpGM.html" rel="bookmark" class="title">js面向对象</a>
					<div>
						前言 当今 JavaScript 大行其道,各种应用对其依赖日深.web 程序员已逐渐习惯使用各种优秀的 JavaScript 框架快速开发 Web 应用,从而忽略了对原生 JavaScript 的学 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35beWV4.html" rel="bookmark" class="title">蓝懿 iOS iOS单例销毁</a>
					<div>
						1 单例的实现见之前写过的一篇文章 iOS单例的快速实现 static InstanceClass *instance; + (InstanceClass *)defaultInstance{ @sy ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xRrgB4.html" rel="bookmark" class="title">google支付服务端订单验证PHP代码</a>
					<div>
						之前有转发一则关于google支付服务端验证的文章,今天把之前研究出得服务端订单支付验证代码(PHP版本)贴出来大家分享 在进行服务端交易验证之前,需要到google api consle后台http ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoG8rnM.html" rel="bookmark" class="title">web工作过程</a>
					<div>
						了解浏览器与服务器进行通信和访问的过程 打开浏览器-输入URL地址 当我们访问一个网页时,如http://www.baidu.com,这个网址包含四个部分的内容: 1.第一部分:协议类型:这里是htt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3O7Jrg3.html" rel="bookmark" class="title">站立会议总结DAY02</a>
					<div>
						1.昨天做了什么:做出了一个大概的界面(APP的个人中心界面),有用户名信息和按钮. 2.今天准备做什么:因为仅是完成在页面上显示文字,而显示个人信息的化,想要做成微信的个人中心辣个样子. ①就是文字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Q8K9w3.html" rel="bookmark" class="title">全域哈希和完全哈希</a>
					<div>
						1.直接映射表 查找数据时,直接定位,时间复杂度为:O(1): 局限性:浪费大量的内存空间: 2.哈希表 (1).用一个哈希函数Hash()来随机映射那些键: 抽象模型 (2).哈希冲突时: i.链地 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aO8ZA4.html" rel="bookmark" class="title">&lbrack;Linux&rsqb;Linux下redis的安装及配置&period;</a>
					<div>
						在上一篇[Linux] linux下安装配置 zookeeper/redis/solr/tomcat/IK分词器 详细实例. 我们已经将redis所需tar包拷贝到了linux下的root 根目录下, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLPxDEM.html" rel="bookmark" class="title">数据的动态合并和导出至EXCEL</a>
					<div>
						最近一段时间都在处理数据的动态合并和导出EXCEL的问题,写个demo记录下,希望和我碰到同样问题的博友可以顺利解决:后面会提供demo下载链接. (VS2012,ASP.NET) 一.主要解决以下问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODVw74.html" rel="bookmark" class="title">python学习日记&lbrack;2&rsqb;</a>
					<div>
						元组:(用()) 和列表的不同: 1. 列表更加灵活,可以任意的添加删除元素,元组一旦被创建就不可更改: &gt;&gt;&gt; dir(test) ['__add__', '__class__', ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pPynJ4.html" rel="bookmark" class="title">js的水仙花数的输出</a>
					<div>
						&lt;!DOCTYPE html&gt;&lt;html lang=&quot;en&quot;&gt;&lt;head&gt; &lt;meta charset=&quot;UTF-8&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0R7Xap3.html" rel="bookmark" class="title">IOS6  字典的排序应用</a>
					<div>
						#import &lt;Foundation/Foundation.h&gt; static NSString * const kName = @&quot;name&quot;; static NS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bRk7m0.html" rel="bookmark" class="title">使用autolayout常见错误</a>
					<div>
						1:The view hierarchy is not prepared for the constraint: &lt;NSLayoutConstraint:0x8e82e40 UISearchBa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Aalwz4.html" rel="bookmark" class="title">java 获取网页指定内容</a>
					<div>
						import java.io.BufferedReader; import java.io.InputStreamReader; import java.net.HttpURLConnection;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OXbn84.html" rel="bookmark" class="title">add&period;name</a>
					<div>
						// named function expression var add = function add(a, b) { return a + b; }; // anonymous function v ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWdzZy0.html" rel="bookmark" class="title">ORACLE 行转列的通用过程</a>
					<div>
						--测试数据create table rowtocol_test asselect 2009 year,1 month,'部门1' dept,50000 expenditure from dualun ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49wNJ10.html" rel="bookmark" class="title">&lbrack;C&num;&rsqb; Assert&period;AreEqual DateTime</a>
					<div>
						示例代码: [TestMethod()] public void DateTimeFromUnixTimestampMillisTest() { DateTime _actual = UnixEpoc ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
